<%@page import="ChartDirector.*" %>
<%@page import="java.util.*" %>
<%@page import="ddproject.*" %>

<%
//the names of the tasks
String[] labels = (String [])request.getAttribute("theLabels");

//the planned start dates and end dates for the tasks
Date[] startDate = (Date[] ) request.getAttribute("theStartDates");
Date[] endDate = (Date []) request.getAttribute("theEndDates");

//the actual start dates and end dates for the tasks up to now
Date[] actualStartDate = startDate;
Date[] actualEndDate = (Date[]) request.getAttribute("theActualDates");
Date chartStart = (Date) request.getAttribute("chartStart");
Date chartEnd = (Date) request.getAttribute("chartEnd");
int delta =((Integer) request.getAttribute("delta")).intValue();
int sizex = ((Integer) request.getAttribute("sizex")).intValue();
int sizey = ((Integer) request.getAttribute("sizey")).intValue();
Vector projectTasks = (Vector) request.getAttribute("theTasks");
Vector theDependencies = (Vector) request.getAttribute("theDependencies");
Vector theCriticalPath = (Vector) request.getAttribute("theCriticalPath");

//Create a XYChart object of size 620 x 280 pixels. Set background color to
//light green (ccffcc) with 1 pixel 3D border effect.
XYChart c = new XYChart(sizex+10, sizey+50 , 0xc8d0d4, 0x0, 1);

//Add a title to the chart using 15 points Times Bold Itatic font, with white
//(ffffff) text on a dark green (0x6000) background


//Set the plotarea at (140, 55) and of size 460 x 200 pixels. Use alternative
//white/grey background. Enable both horizontal and vertical grids by setting
//their colors to grey (c0c0c0). Set vertical major grid (represents month
//boundaries) 2 pixels in width
c.setPlotArea(5, 40, sizex, sizey, 0xffffff, 0xeeeeee, Chart.LineColor, 0xc0c0c0,
    0xc0c0c0).setGridWidth(2, 1, 1, 1);

//swap the x and y axes to create a horziontal box-whisker chart
c.swapXY();

//Set the y-axis scale to be date scale from Aug 16, 2004 to Nov 22, 2004, with
//ticks every 7 days (1 week)
c.yAxis().setDateScale(Chart.CTime(chartStart),
    Chart.CTime(chartEnd), 86400 * delta);


//Add a red (ff0000) dash line to represent the current day
c.yAxis().addMark(Chart.CTime(Calendar.getInstance().getTime()),
    c.dashLineColor(0xff0000, Chart.DashLine));

//Set multi-style axis label formatting. Month labels are in Arial Bold font in
//"mmm d" format. Weekly labels just show the day of month and use minor tick
//(by using '-' as first character of format string).
c.yAxis().setMultiFormat(Chart.StartOfMonthFilter(),
    "<*font=Arial Bold*>{value|mmm d}", Chart.StartOfDayFilter(), "-{value|d}");

//Set the y-axis to shown on the top (right + swapXY = top)
c.setYAxisOnRight();

//Set the labels on the x axis
c.xAxis().setLabels(labels);

//Reverse the x-axis scale so that it points downwards.
c.xAxis().setReverse();

//Set the horizontal ticks and grid lines to be between the bars
c.xAxis().setTickOffset(0.5);

//Use blue (0000aa) as the color for the planned schedule
int plannedColor = 0xaa;

//Use a red hash pattern as the color for the actual dates. The pattern is
//created as a 4 x 4 bitmap defined in memory as an array of colors.
int actualColor = c.patternColor(new int[]{0xffffff, 0xffffff, 0xffffff,
    0xff0000, 0xffffff, 0xffffff, 0xff0000, 0xffffff, 0xffffff, 0xff0000,
    0xffffff, 0xffffff, 0xff0000, 0xffffff, 0xffffff, 0xffffff}, 4);

//Add a box whisker layer to represent the actual dates. We add the actual dates
//layer first, so it will be the top layer.
BoxWhiskerLayer actualLayer = c.addBoxLayer(Chart.CTime(actualStartDate),
    Chart.CTime(actualEndDate), actualColor, "Percentage");

//Set the bar height to 8 pixels so they will not block the bottom bar
actualLayer.setDataWidth(8);


    int selected_item1=-1;
    int selected_item2=-1;
    String selected_task1 = (String)session.getAttribute("ganttTask1");
    String selected_task2 = (String)session.getAttribute("ganttTask2");
    int colors[]=new int[projectTasks.size()];
    for(int i=0; i<projectTasks.size(); i++){        
        Task aTask=(Task)projectTasks.get(i);
        if(DProjectUtil.intToString(aTask.getTask_id()).equals(selected_task1)){
           colors[i] = 0x444444;
        }else if(DProjectUtil.intToString(aTask.getTask_id()).equals(selected_task2)){
           colors[i] = 0xbbbbbb;
        }else if(mainFrame_aProject_DetailedGanttChartServlet.is_contain(theCriticalPath,aTask.getTask_id())){
            colors[i] = 0xff0000;
        }else{
            colors[i] = plannedColor;
        }
    }  

   
//Add a box-whisker layer to represent the planned schedule date
BoxWhiskerLayer plannedLayer = c.addBoxWhiskerLayer2(Chart.CTime(startDate), Chart.CTime(endDate), null,null,null,colors);

plannedLayer.setBorderColor(Chart.SameAsMainColor);


//Add a legend box on the top right corner (595, 60) of the plot area with 8 pt
//Arial Bold font. Use a semi-transparent grey (80808080) background.
LegendBox b = c.addLegend(sizex, 40, false, "Arial Bold", 8);
b.setAlignment(Chart.TopRight);
b.setBackground(0x80808080, -1, 2);


for(int i=0;i<theDependencies.size();i++){
   TaskDependency theDependency = (TaskDependency)theDependencies.elementAt(i);
   //DEPENDENCY TYPE a gore degisecek 
   int xvalue1=0;
   int xvalue2=0;
   for(int j=0;j<projectTasks.size();j++){
    if(((Task)projectTasks.elementAt(j)).getTask_id()== theDependency.getTask_ID1())
        xvalue1=j;
    else if(((Task)projectTasks.elementAt(j)).getTask_id()== theDependency.getTask_ID2())
        xvalue2=j;
   }
   
   if(theDependency.getDependency_type()==0){   //finish-to-start
         c.addScatterLayer(new double[]{xvalue1}, Chart.CTime(new Date[]{theDependency.getEnd_date1()}), "", Chart.CircleSymbol, 13, 0x33ff33 );
         c.addScatterLayer(new double[]{xvalue2}, Chart.CTime(new Date[]{theDependency.getStart_date2()}), "", Chart.RightTriangleSymbol, 13, 0x33ff33 );
   }else{
         c.addScatterLayer(new double[]{xvalue1}, Chart.CTime(new Date[]{theDependency.getStart_date1()}), "", Chart.CircleSymbol, 13, 0x33ff33 );
         c.addScatterLayer(new double[]{xvalue2}, Chart.CTime(new Date[]{theDependency.getStart_date2()}), "", Chart.CircleSymbol, 13, 0x33ff33 );
   } 
}

for(int i=0;i<theDependencies.size();i++){
   TaskDependency theDependency = (TaskDependency)theDependencies.elementAt(i);
   //DEPENDENCY TYPE a gore degisecek 
   int xvalue1=0;
   int xvalue2=0;
   for(int j=0;j<projectTasks.size();j++){
    if(((Task)projectTasks.elementAt(j)).getTask_id()== theDependency.getTask_ID1())
        xvalue1=j;
    else if(((Task)projectTasks.elementAt(j)).getTask_id()== theDependency.getTask_ID2())
        xvalue2=j;
   }
   c.layout();
   int ycoor1 = plannedLayer.getXCoor(xvalue1);   
   int xcoor1 =0;
   int ycoor2 = plannedLayer.getXCoor(xvalue2);
   int xcoor2 =0;
   
    if(theDependency.getDependency_type()==0){   //finish-to-start
       xcoor1 = plannedLayer.getYCoor(Chart.CTime(theDependency.getEnd_date1()));      //the end of the first to
       xcoor2 = plannedLayer.getYCoor(Chart.CTime(theDependency.getStart_date2()));   //the start of other
       int line_color=0x000000;
       if(mainFrame_aProject_DetailedGanttChartServlet.is_contain(theCriticalPath,theDependency.getTask_ID1())&& 
          mainFrame_aProject_DetailedGanttChartServlet.is_contain(theCriticalPath,theDependency.getTask_ID2()))
          line_color=0xff0000;
       
       c.addLine(xcoor1,ycoor1,(xcoor2+xcoor1)/2,ycoor1,line_color,3);
       c.addLine((xcoor2+xcoor1)/2,ycoor1,(xcoor2+xcoor1)/2,ycoor2,line_color,3);
       c.addLine((xcoor2+xcoor1)/2,ycoor2,xcoor2,ycoor2,line_color,3);
    }else{
       xcoor1 = plannedLayer.getYCoor(Chart.CTime(theDependency.getStart_date1()));      //the end of the first to
       xcoor2 = plannedLayer.getYCoor(Chart.CTime(theDependency.getStart_date2()));   //the start of other
       c.addLine(xcoor1,ycoor1,xcoor2,ycoor1,0x000000,3);
       c.addLine(xcoor2,ycoor1,xcoor2,ycoor2,0x000000,3);    
    }
}
    

//output the chart
String chart1URL = c.makeSession(request, "chart1");
%>

<%
//******************************PARAMETERS***************************
String start_date = DProjectUtil.dateToString((Date)request.getAttribute("start_date"),'/');
String end_date = DProjectUtil.dateToString((Date)request.getAttribute("end_date"),'/');
String chart_date = DProjectUtil.dateToString(chartStart,'/');
String chart_view = (String)request.getAttribute("chart_view");


GregorianCalendar cd = new GregorianCalendar();
cd.setTime(DProjectUtil.stringToDate(chart_date));
int chart_month = cd.get(Calendar.MONTH)+1;
int chart_year = cd.get(Calendar.YEAR);
int chart_size = DProjectUtil.stringToInt((String)request.getAttribute("tasks_size"));



//include tool tip for the chart
String imageMap1 = c.getHTMLImageMap("detailedGanttClick.jsp?command=select&chart_date="+chart_date+"&view="+chart_view, "",
    "title='{xLabel}'");
%>

<html>
<head>
<link rel="stylesheet" type="text/css" media="all" href="jscalendar-1.0/calendar-win2k-cold-1.css" title="win2k-cold-1" />
<link rel="stylesheet" type="text/css" href="ddsoftware.css" />
<script type="text/javascript" src="jscalendar-1.0/calendar.js"></script>
  <script type="text/javascript" src="jscalendar-1.0/lang/calendar-en.js"></script>
  <script type="text/javascript" src="jscalendar-1.0/calendar-setup.js"></script>
  <script type="text/javascript" src="scripts.js"></script>
</head>
<body topmargin="5" leftmargin="5" rightmargin="0">
<table width="100%">
 <tr>
    <td width="50%">
    <div align="left">&nbsp;&nbsp;&nbsp;<font size="+2"><strong><u>Dependency Chart</u></strong></font></div> 
    </td>
 </tr>
</table>

<table cellpadding="0" cellspacing="0">
<tr>
    <td>
    <table border="0" cellpadding="5" cellspacing="5" align="left">
      <tr>
        <td ><div align="center">&nbsp;</div></td>
      </tr>
    <form name="viewForm" method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
    <tr align="left">
        <td><strong>Select Your Viev:</strong></td>
        <td>
            <select name="view" onchange="submitViewForm()">
                <option value="monthly" <%if(chart_view.equals("monthly")){%>selected<%}%> >Monthly View</option>
                <option value="yearly" <%if(chart_view.equals("yearly")){%>selected<%}%> >Yearly View</option>
                <option value="interval" <%if(chart_view.equals("interval")){%>selected<%}%> >View Interval</option>
            </select>
        </td>
        <td> 
            <input type="hidden" name="command" value="view_change"/>
            <input type="hidden" name="chart_date" value="<%=chart_date%>">
        </td>
    </tr>
    </form>

    <%if(chart_view.equals("interval")){%>
    <form name="chartForm" method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
    <tr align="left">
        <td>Chart Start Date:<input type="text" readonly="readonly" name="start_date" size="10" value="<%=start_date%>"/><img src="jscalendar-1.0/img.gif" id="s_trigger" style="cursor: pointer; border: 1px solid blue;" title="Date selector"
                                                onmouseover="this.style.background='red';" onmouseout="this.style.background=''" />
                                                <script type="text/javascript">
                                                    Calendar.setup({
                                                        inputField     :    "start_date",     // id of the input field
                                                        ifFormat       :    "%d/%m/%Y",      // format of the input field
                                                        button         :    "s_trigger",  // trigger for the calendar (button ID)
                                                        align          :    "Tl",           // alignment (defaults to "Bl")
                                                        singleClick    :    true
                                                    });
                                                </script>
        </td>
        <td>Chart End Date:<input type="text" readonly="readonly" name="end_date" size="10" value="<%=end_date%>"/><img src="jscalendar-1.0/img.gif" id="d_trigger" style="cursor: pointer; border: 1px solid blue;" title="Date selector"
                                                onmouseover="this.style.background='red';" onmouseout="this.style.background=''" />
                                                <script type="text/javascript">
                                                    Calendar.setup({
                                                        inputField     :    "end_date",     // id of the input field
                                                        ifFormat       :    "%d/%m/%Y",      // format of the input field
                                                        button         :    "d_trigger",  // trigger for the calendar (button ID)
                                                        align          :    "Tl",           // alignment (defaults to "Bl")
                                                        singleClick    :    true
                                                    });
                                                </script>
        </td>
        <td>
            <input type="hidden" name="command" value="view_interval"/>
            <input type="hidden" name="view" value="<%=chart_view%>">
            <input type="submit" name="submit" value="VIEW INTERVAL"/> 
        </td>
    </tr>
    </form>
    <%}%>
    </table>
    </td>
</tr>
<tr>
<td>

<table align="center" width="30%">
<%if(!chart_view.equals("interval")){%>
<tr>
    <td>&nbsp;</td>
    <td align="center"><strong>Select <%if(chart_view.equals("monthly")){%>Month<%}else{%>Year<%}%></strong></td
    <td>&nbsp;</td>
</tr>
<tr>
<form name="previousForm" method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
    <td>
     <img src="prev1.gif" onclick="submitPreviousForm()" alt="<%if(chart_view.equals("monthly")){%>Previous Month<%}else{%>Previous Year<%}%>"/>
     <input type="hidden" name="command" value="previous"/>
     <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
     <input type="hidden" name="view" value="<%=chart_view%>">
    </td>
</form>
    
<form name="monthSelectionForm" method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
    <td align="center">
         <input type="hidden" name="command" value="goto_month_or_year"/>
        <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
        <input type="hidden" name="view" value="<%=chart_view%>"/>
        
        <%if(chart_view.equals("monthly")){%>
            <select name="month" onchange="submitMonthForm()">
                <option value="1" <%if(chart_month==1){%> selected <%}%> >January</option>
                <option value="2" <%if(chart_month==2){%> selected <%}%> >February</option>
                <option value="3" <%if(chart_month==3){%> selected <%}%> >March</option>
                <option value="4" <%if(chart_month==4){%> selected <%}%> >April</option>
                <option value="5" <%if(chart_month==5){%> selected <%}%> >May</option>
                <option value="6" <%if(chart_month==6){%> selected <%}%> >June</option>
                <option value="7" <%if(chart_month==7){%> selected <%}%> >July</option>
                <option value="8" <%if(chart_month==8){%> selected <%}%> >August</option>
                <option value="9" <%if(chart_month==9){%> selected <%}%> >Semptember</option>
                <option value="10" <%if(chart_month==10){%> selected <%}%> >October</option>
                <option value="11" <%if(chart_month==11){%> selected <%}%> >November</option>
                <option value="12" <%if(chart_month==12){%> selected <%}%> >December</option>                
            </select>
        <%}else {%>
            <input type="text" name="year" value="<%=chart_year%>"></input>
            <input type="submit" name="submit" value="GO"/>
        <%}%>
    </td>
</form>    
<form name="nextForm" method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
    <td>
       <img src="next1.gif" onclick="submitNextForm()" alt="<%if(chart_view.equals("monthly")){%>Next Month<%}else{%>Next Year<%}%>"/>
       <input type="hidden" name="command" value="next">
       <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
       <input type="hidden" name="view" value="<%=chart_view%>">
    </td>
</form>
</tr>
<%}else{%>
    <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
    </tr>
<%}%>
</table>
</td>
</tr>
<tr>
<td>
<table class="form_table" border="0" cellpadding="0" cellspacing="0">
<tr>
    <td width="30%" nowrap>
        <table border="1" cellpadding="1" cellspacing="0">
            <tr>
                <td nowrap><font color="#000000"><strong>Task ID</strong></font></td>
                <td nowrap><font color="#000000"><strong>Task Name</strong></font></td>
            </tr>
            <%for(int i=0; i<projectTasks.size(); i++)
            {%>
                 <tr>
                    <td nowrap><%= ((Task)projectTasks.get(i)).getTask_id()%></td>
                    <td nowrap><%= ((Task)projectTasks.get(i)).getTask_description()%></td>
                </tr>
            <%}%>
        </table>
    </td>
    <td width="70%">
    <table>
        <tr>
            <td>
                <img src='<%=response.encodeURL("getchart.jsp?"+chart1URL)%>' usemap="#map1" border="0">
                <map name="map1"><%=imageMap1%></map>
            </td>
        </tr>
    </table>    
    </td>
</tr>
</table>
</td>
</tr>
</table>
<div></div>
<table>
    <tr>
        <td>
        <form method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
          
            <select name="dependency_type">
                <option value="0">Finish-to-Start</option>
                <option value="1">Start-to-Start</option>
            </select>
                <input type="hidden" name="command" value="add_dependency"/>
                <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
                <input type="hidden" name="view" value="<%=chart_view%>"/>
                <input type="submit" name="submit" value="Add Dependency"/>
          
         </form>
        </td>       
        <td>
             <form method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
                <input type="hidden" name="command" value="delete_dependency"/>
                <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
                <input type="hidden" name="view" value="<%=chart_view%>"/>
                <input type="submit" name="submit" value="Delete Dependency"/>
             </form>
        </td>
        <td>
             <form method="post" action="mainFrame_aProject_DetailedGanttChartServlet">
                <input type="hidden" name="command" value="back"/>
                <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
                <input type="hidden" name="view" value="<%=chart_view%>"/>
                <input type="submit" name="submit" value="Back"/>
             </form>
        </td>
    </tr>
</table>
</body>
</html>


