<%@page import="ChartDirector.*" %>
<%@page import="java.util.*" %>
<%@page import="ddproject.*" %>

<%
//the names of the tasks
String[] labels = (String [])request.getAttribute("theLabels");

//the planned start dates and end dates for the tasks
Date[] startDate = (Date[] ) request.getAttribute("theStartDates");
Date[] endDate = (Date []) request.getAttribute("theEndDates");

//the actual start dates and end dates for the tasks up to now
Date[] actualStartDate = startDate;
Date[] actualEndDate = (Date[]) request.getAttribute("theActualDates");
Date chartStart = (Date) request.getAttribute("chartStart");
Date chartEnd = (Date) request.getAttribute("chartEnd");
int delta =((Integer) request.getAttribute("delta")).intValue();
int sizex = ((Integer) request.getAttribute("sizex")).intValue();
int sizey = ((Integer) request.getAttribute("sizey")).intValue();
Vector projectTasks = (Vector) request.getAttribute("theTasks");

//Create a XYChart object of size 620 x 280 pixels. Set background color to
//light green (ccffcc) with 1 pixel 3D border effect.
XYChart c = new XYChart(sizex+10, sizey+50 , 0xc8d0d4, 0x0, 1);

//Add a title to the chart using 15 points Times Bold Itatic font, with white
//(ffffff) text on a dark green (0x6000) background


//Set the plotarea at (140, 55) and of size 460 x 200 pixels. Use alternative
//white/grey background. Enable both horizontal and vertical grids by setting
//their colors to grey (c0c0c0). Set vertical major grid (represents month
//boundaries) 2 pixels in width
c.setPlotArea(5, 40, sizex, sizey, 0xffffff, 0xeeeeee, Chart.LineColor, 0xc0c0c0,
    0xc0c0c0).setGridWidth(2, 1, 1, 1);

//swap the x and y axes to create a horziontal box-whisker chart
c.swapXY();

//Set the y-axis scale to be date scale from Aug 16, 2004 to Nov 22, 2004, with
//ticks every 7 days (1 week)
c.yAxis().setDateScale(Chart.CTime(chartStart),
    Chart.CTime(chartEnd), 86400 * delta);


//Add a red (ff0000) dash line to represent the current day
c.yAxis().addMark(Chart.CTime(Calendar.getInstance().getTime()),
    c.dashLineColor(0xff0000, Chart.DashLine));

//Set multi-style axis label formatting. Month labels are in Arial Bold font in
//"mmm d" format. Weekly labels just show the day of month and use minor tick
//(by using '-' as first character of format string).
c.yAxis().setMultiFormat(Chart.StartOfMonthFilter(),
    "<*font=Arial Bold*>{value|mmm d}", Chart.StartOfDayFilter(), "-{value|d}");

//Set the y-axis to shown on the top (right + swapXY = top)
c.setYAxisOnRight();

//Set the labels on the x axis
c.xAxis().setLabels(labels);

//Reverse the x-axis scale so that it points downwards.
c.xAxis().setReverse();

//Set the horizontal ticks and grid lines to be between the bars
c.xAxis().setTickOffset(0.5);

//Use blue (0000aa) as the color for the planned schedule
int plannedColor = 0xaa;

//Use a red hash pattern as the color for the actual dates. The pattern is
//created as a 4 x 4 bitmap defined in memory as an array of colors.
int actualColor = c.patternColor(new int[]{0xffffff, 0xffffff, 0xffffff,
    0xff0000, 0xffffff, 0xffffff, 0xff0000, 0xffffff, 0xffffff, 0xff0000,
    0xffffff, 0xffffff, 0xff0000, 0xffffff, 0xffffff, 0xffffff}, 4);

//Add a box whisker layer to represent the actual dates. We add the actual dates
//layer first, so it will be the top layer.
BoxWhiskerLayer actualLayer = c.addBoxLayer(Chart.CTime(actualStartDate),
    Chart.CTime(actualEndDate), actualColor, "Percentage");

//Set the bar height to 8 pixels so they will not block the bottom bar
actualLayer.setDataWidth(8);

//Add a box-whisker layer to represent the planned schedule date
c.addBoxLayer(Chart.CTime(startDate), Chart.CTime(endDate), plannedColor,
    "Planned").setBorderColor(Chart.SameAsMainColor);

//Add a legend box on the top right corner (595, 60) of the plot area with 8 pt
//Arial Bold font. Use a semi-transparent grey (80808080) background.
LegendBox b = c.addLegend(sizex, 40, false, "Arial Bold", 8);
b.setAlignment(Chart.TopRight);
b.setBackground(0x80808080, -1, 2);

//output the chart
String chart1URL = c.makeSession(request, "chart1");

//include tool tip for the chart
String imageMap1 = c.getHTMLImageMap("ganttClick.jsp", "",
    "title='{xLabel}'");
%>

<%
//******************************PARAMETERS***************************
String start_date = DProjectUtil.dateToString((Date)request.getAttribute("start_date"),'/');
String end_date = DProjectUtil.dateToString((Date)request.getAttribute("end_date"),'/');
String chart_date = DProjectUtil.dateToString(chartStart,'/');
String chart_view = (String)request.getAttribute("chart_view");
int chart_index = DProjectUtil.stringToInt((String)request.getAttribute("chart_index"));

GregorianCalendar cd = new GregorianCalendar();
cd.setTime(DProjectUtil.stringToDate(chart_date));
int chart_month = cd.get(Calendar.MONTH)+1;
int chart_year = cd.get(Calendar.YEAR);
int index_delta = DProjectUtil.stringToInt((String)request.getAttribute("index_delta"));
int chart_size = DProjectUtil.stringToInt((String)request.getAttribute("tasks_size"));
int chart_end_index = DProjectUtil.stringToInt((String)request.getAttribute("chart_end_index"));
Vector users = (Vector)request.getAttribute("users");
%>

<html>
<head>
<link rel="stylesheet" type="text/css" media="all" href="jscalendar-1.0/calendar-win2k-cold-1.css" title="win2k-cold-1" />
<link rel="stylesheet" type="text/css" href="ddsoftware.css" />
<script type="text/javascript" src="jscalendar-1.0/calendar.js"></script>
  <script type="text/javascript" src="jscalendar-1.0/lang/calendar-en.js"></script>
  <script type="text/javascript" src="jscalendar-1.0/calendar-setup.js"></script>
  <script type="text/javascript" src="scripts.js"></script>
</head>
<body topmargin="5" leftmargin="5" rightmargin="0">

<table width="100%">
 <tr>
    <td width="70%">
    <div align="left">&nbsp;&nbsp;&nbsp;<font size="+2"><strong><u>Gantt Chart</u></strong></font></div> 
    </td>
    <td width="%30" align=right><a href="mainFrame_aProject_DetailedGanttChartServlet">Dependency Chart</a></td>
 </tr>
</table>


<table cellpadding="0" cellspacing="0">
<tr>
    <td>
    <table border="0" cellpadding="5" cellspacing="5" align="left">
      <tr>
        <td ><div align="center">&nbsp;</div></td>
      </tr>
    <form name="viewForm" method="post" action="mainFrame_aProject_GanttChartServlet">
    <tr align="left">
        <td><strong>Select Your Viev:</strong></td>
        <td>
            <select name="view" onchange="submitViewForm()">
                <option value="monthly" <%if(chart_view.equals("monthly")){%>selected<%}%> >Monthly View</option>
                <option value="yearly" <%if(chart_view.equals("yearly")){%>selected<%}%> >Yearly View</option>
                <option value="interval" <%if(chart_view.equals("interval")){%>selected<%}%> >View Interval</option>
            </select>
        </td>
        <td> 
            <input type="hidden" name="command" value="view_change"/>
            <input type="hidden" name="chart_index" value="<%=chart_index%>"/>
            <input type="hidden" name="chart_date" value="<%=chart_date%>">
        </td>
    </tr>
    </form>

    <%if(chart_view.equals("interval")){%>
    <form name="chartForm" method="post" action="mainFrame_aProject_GanttChartServlet">
    <tr align="left">
        <td>Chart Start Date:<input type="text" readonly="readonly" name="start_date" size="10" value="<%=start_date%>"/><img src="jscalendar-1.0/img.gif" id="s_trigger" style="cursor: pointer; border: 1px solid blue;" title="Date selector"
                                                onmouseover="this.style.background='red';" onmouseout="this.style.background=''" />
                                                <script type="text/javascript">
                                                    Calendar.setup({
                                                        inputField     :    "start_date",     // id of the input field
                                                        ifFormat       :    "%d/%m/%Y",      // format of the input field
                                                        button         :    "s_trigger",  // trigger for the calendar (button ID)
                                                        align          :    "Tl",           // alignment (defaults to "Bl")
                                                        singleClick    :    true
                                                    });
                                                </script>
        </td>
        <td>Chart End Date:<input type="text" readonly="readonly" name="end_date" size="10" value="<%=end_date%>"/><img src="jscalendar-1.0/img.gif" id="d_trigger" style="cursor: pointer; border: 1px solid blue;" title="Date selector"
                                                onmouseover="this.style.background='red';" onmouseout="this.style.background=''" />
                                                <script type="text/javascript">
                                                    Calendar.setup({
                                                        inputField     :    "end_date",     // id of the input field
                                                        ifFormat       :    "%d/%m/%Y",      // format of the input field
                                                        button         :    "d_trigger",  // trigger for the calendar (button ID)
                                                        align          :    "Tl",           // alignment (defaults to "Bl")
                                                        singleClick    :    true
                                                    });
                                                </script>
        </td>
        <td>
            <input type="hidden" name="command" value="view_interval"/>
            <input type="hidden" name="chart_index" value="<%=chart_index%>">
            <input type="hidden" name="view" value="<%=chart_view%>">
            <input type="submit" name="submit" value="VIEW INTERVAL"/> 
        </td>
    </tr>
    </form>
    <%}%>
    </table>
    </td>
</tr>
<tr>
<td>

<table align="center" width="30%">
<%if(!chart_view.equals("interval")){%>
<tr>
    <td>&nbsp;</td>
    <td align="center"><strong>Select <%if(chart_view.equals("monthly")){%>Month<%}else{%>Year<%}%></strong></td
    <td>&nbsp;</td>
</tr>
<tr>
<form name="previousForm" method="post" action="mainFrame_aProject_GanttChartServlet">
    <td>
     <img src="prev1.gif" onclick="submitPreviousForm()" alt="<%if(chart_view.equals("monthly")){%>Previous Month<%}else{%>Previous Year<%}%>"/>
     <input type="hidden" name="command" value="previous"/>
     <input type="hidden" name="chart_index" value="<%=chart_index%>"/>
     <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
     <input type="hidden" name="view" value="<%=chart_view%>">
    </td>
</form>
    
<form name="monthSelectionForm" method="post" action="mainFrame_aProject_GanttChartServlet">
    <td align="center">
         <input type="hidden" name="command" value="goto_month_or_year"/>
        <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
        <input type="hidden" name="chart_index" value="<%=chart_index%>"/>
        <input type="hidden" name="view" value="<%=chart_view%>"/>
        
        <%if(chart_view.equals("monthly")){%>
            <select name="month" onchange="submitMonthForm()">
                <option value="1" <%if(chart_month==1){%> selected <%}%> >January</option>
                <option value="2" <%if(chart_month==2){%> selected <%}%> >February</option>
                <option value="3" <%if(chart_month==3){%> selected <%}%> >March</option>
                <option value="4" <%if(chart_month==4){%> selected <%}%> >April</option>
                <option value="5" <%if(chart_month==5){%> selected <%}%> >May</option>
                <option value="6" <%if(chart_month==6){%> selected <%}%> >June</option>
                <option value="7" <%if(chart_month==7){%> selected <%}%> >July</option>
                <option value="8" <%if(chart_month==8){%> selected <%}%> >August</option>
                <option value="9" <%if(chart_month==9){%> selected <%}%> >Semptember</option>
                <option value="10" <%if(chart_month==10){%> selected <%}%> >October</option>
                <option value="11" <%if(chart_month==11){%> selected <%}%> >November</option>
                <option value="12" <%if(chart_month==12){%> selected <%}%> >December</option>                
            </select>
        <%}else {%>
            <input type="text" name="year" value="<%=chart_year%>"></input>
            <input type="submit" name="submit" value="GO"/>
        <%}%>
    </td>
</form>    
<form name="nextForm" method="post" action="mainFrame_aProject_GanttChartServlet">
    <td>
       <img src="next1.gif" onclick="submitNextForm()" alt="<%if(chart_view.equals("monthly")){%>Next Month<%}else{%>Next Year<%}%>"/>
       <input type="hidden" name="command" value="next">
       <input type="hidden" name="chart_index" value="<%=chart_index%>"/>
       <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
       <input type="hidden" name="view" value="<%=chart_view%>">
    </td>
</form>
</tr>
<%}else{%>
    <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
    </tr>
<%}%>
</table>
</td>
</tr>
<tr>
<td>
<table class="form_table" border="0" cellpadding="0" cellspacing="0">
<tr>
    <td width="30%" nowrap>
        <table border="1" cellpadding="1" cellspacing="0">
            <tr>
                <td nowrap><font color="#000000"><strong>Task ID</strong></font></td>
                <td nowrap><font color="#000000"><strong>Task Name</strong></font></td>
            </tr>
            <%for(int i=0; i<projectTasks.size(); i++)
            {%>
                 <tr>
                    <td nowrap><%= ((Task)projectTasks.get(i)).getTask_id()%></td>
                    <td nowrap><%= ((Task)projectTasks.get(i)).getTask_description()%></td>
                </tr>
            <%}%>
        </table>
    </td>
    <td width="70%">
    <table>
        <tr>
            <td>
                <img src='<%=response.encodeURL("getchart.jsp?"+chart1URL)%>' usemap="#map1" border="0">
                <map name="map1"><%=imageMap1%></map>
            </td>
        </tr>
    </table>    
    </td>
</tr>
</table>
</td>
</tr>
<tr>
<td>
<table  align="center" width="30%">
    <tr>
    <form name="previousIndexForm" method="post" action="mainFrame_aProject_GanttChartServlet">
        <td>
            <%if(chart_index>0){%>
            <img src="prev1.gif" onclick="submitPreviousIndexForm()" alt="Previous <%=index_delta%> Tasks"/>
            <%}else{%>
            <img src="prev2.gif"/>
            <%}%>
            <input type="hidden" name="command" value="previousIndex">
            <input type="hidden" name="chart_index" value="<%=chart_index%>"/>
            <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
            <input type="hidden" name="start_date" value="<%=start_date%>"/>
            <input type="hidden" name="end_date" value="<%=end_date%>"/>
            <input type="hidden" name="view" value="<%=chart_view%>">
        </td>
    </form>
        <td align="center"><label>Tasks <%=chart_index%>-<%=chart_end_index%></label></td>
    <form name="nextIndexForm" method="post" action="mainFrame_aProject_GanttChartServlet"> 
        <td>
            <%if(chart_end_index<chart_size){%>
                <img src="next1.gif" onclick="submitNextIndexForm()" alt="Next <%=chart_end_index-chart_index%> Tasks"/>
            <%}else{%>
                <img src="next2.gif"/>
            <%}%>
            <input type="hidden" name="command" value="nextIndex"/>
            <input type="hidden" name="chart_index" value="<%=chart_index%>"/>
            <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
            <input type="hidden" name="start_date" value="<%=start_date%>"/>
            <input type="hidden" name="end_date" value="<%=end_date%>"/>
            <input type="hidden" name="view" value="<%=chart_view%>">
        </td>
    </form>
    </tr>
</table>
</td>
</tr>

<tr width="40%">
    <table align="center" width="40%" class="form_table" border="1" cellpadding="2" cellspacing="2">
        <form name="gtForm" method="post" action="mainFrame_aProject_GanttChartServlet">
        <tr width="40%" bgcolor="#C0C0C0">
                   <td bgcolor="#C0C0C0" width="1%"><strong>ID</strong></td>              	   
              	   <td bgcolor="#C0C0C0" width="10%"><strong>Task Name</strong></td>
              	   <td bgcolor="#C0C0C0" width="7%"><strong>Start Date</strong></td>
              	   <td bgcolor="#C0C0C0" width="7%"><strong>End Date</strong></td>
              	   <td bgcolor="#C0C0C0" width="1%"><strong>Est. Hours</strong></td>              	   
              	   <td bgcolor="#C0C0C0" width="8%"><strong>Assign</strong></td>
                   <td bgcolor="#C0C0C0" width="7%"><strong>Assigned Users</strong></td>
        </tr>        
        <%for(int i=0;i<10;i++){%>
        <tr>
            <td><label><%=i%></label></td>              	   
            <td><input type="text" size="35" name="task<%=i%>" value=""/></td>
            <td>
                <input type="text" size="10" name="start<%=i%>"/>
                <img src="jscalendar-1.0/img.gif" id="s_trigger<%=i%>" style="cursor: pointer; border: 1px solid blue;" title="Date selector"
                              onmouseover="this.style.background='red';" onmouseout="this.style.background=''" />
                              <script type="text/javascript">
                              Calendar.setup({
                                inputField     :    "start<%=i%>",     // id of the input field
                                ifFormat       :    "%d/%m/%Y",      // format of the input field
                                showsTime      :    true,            // will display a time selector
                                button         :    "s_trigger<%=i%>",  // trigger for the calendar (button ID)
                                align          :    "Tl",           // alignment (defaults to "Bl")
                                singleClick    :    true
                              });
                              </script>
            </td>
            <td>
                <input type="text" size="10" name="due<%=i%>"/>
                <img src="jscalendar-1.0/img.gif" id="d_trigger<%=i%>" style="cursor: pointer; border: 1px solid blue;" title="Date selector"
                              onmouseover="this.style.background='red';" onmouseout="this.style.background=''" />
                              <script type="text/javascript">
                              Calendar.setup({
                                inputField     :    "due<%=i%>",     // id of the input field
                                ifFormat       :    "%d/%m/%Y",      // format of the input field
                                showsTime      :    true,            // will display a time selector
                                button         :    "d_trigger<%=i%>",  // trigger for the calendar (button ID)
                                align          :    "Tl",           // alignment (defaults to "Bl")
                                singleClick    :    true
                              });
                              </script>
            </td>
            <td>
                <input type="text" size="3" name="estimated<%=i%>"/>
            </td>
            <td>                
                <SELECT MULTIPLE SIZE=2 name="users<%=i%>" id="users<%=i%>">
                   <%for(int j=0;j<users.size();j++){
                        String userid = (String)users.elementAt(j); 
                    %>
                   <option value="<%=userid%>"><%=userid%></option>
                   <%}%> 
                </SELECT>
                <img src="plus.gif" onclick="assignUsers(<%=i%>)" alt="Assign Selected Users"/>
           </td>
            <td>
                <select MULTIPLE SIZE=2 name="assigned<%=i%>" id="assigned<%=i%>">                
                </select>
                <img src="minus.gif" onclick="unassignUsers(<%=i%>)" alt="Unassign Selected Users"/>
            </td>
        </tr>
        <%}%>
        <tr>
            <table align="right">
            <tr align="right">
            <td align="right">
                <input type="hidden" name="command" value="save_tasks"/>
                <input type="hidden" name="chart_index" value="<%=chart_index%>"/>
                <input type="hidden" name="chart_date" value="<%=chart_date%>"/>
                <input type="hidden" name="start_date" value="<%=start_date%>"/>
                <input type="hidden" name="end_date" value="<%=end_date%>"/>
                <input type="hidden" name="view" value="<%=chart_view%>">
                <img src="saveTasks.gif" onclick="submitTaskForm()"/>
            </td>
            <td>&nbsp;</td>
            <td>&nbsp;</td>
            </tr>
            </table>
        </tr>
        </form>
    </table>
</tr>
</table>
</body>
</html>


